import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import Cache from './Cache';
import redis from 'redis';
import redisMock from 'redis-mock';
import lru from 'redis-lru';
var useRedis = process.env.USE_REDIS_IN_SUI_DECORATORS_CACHE;

var Redis =
/*#__PURE__*/
function (_Cache) {
  _inheritsLoose(Redis, _Cache);

  function Redis(_temp) {
    var _this;

    var _ref = _temp === void 0 ? {} : _temp,
        _ref$redisConnection = _ref.redisConnection,
        redisConnection = _ref$redisConnection === void 0 ? {
      host: '127.0.0.1',
      port: 6379
    } : _ref$redisConnection,
        _ref$size = _ref.size,
        size = _ref$size === void 0 ? 100 : _ref$size,
        namespace = _ref.namespace,
        _ref$ttl = _ref.ttl,
        ttl = _ref$ttl === void 0 ? 500 : _ref$ttl;

    _this = _Cache.call(this) || this;
    _this._ttl = ttl;
    _this._redisClient = useRedis ? redis.createClient({
      port: redisConnection.port,
      host: redisConnection.host
    }) : redisMock.createClient();
    _this._lruRedis = lru(_this._redisClient, {
      max: size,
      namespace: namespace
    });
    console.log('Puedo user REDIS %s', useRedis);
    console.log('He construido un conector con redis %j', _this._redisClient);
    console.log('En el constructor de redis ttl %s namespace %s', _this._ttl, namespace);
    return _this;
  }

  var _proto = Redis.prototype;

  _proto.get = function get(key) {
    console.log('En redis me piden la Key %s', key);
    return this._lruRedis.get(key);
  }
  /**
   *
   * @param {string} key
   * @param {string} value
   * @param {number} maxAge expire time in ms, default = 500ms
   */
  ;

  _proto.set = function set(key, value, maxAge) {
    if (maxAge === void 0) {
      maxAge = this._ttl;
    }

    console.log('en redis guardando %j en %s con un TTL de ms %s', value, key, maxAge);
    return this._lruRedis.set(key, value, maxAge);
  };

  _proto.del = function del(key) {
    this._lruRedis.del(key);
  };

  return Redis;
}(Cache);

export { Redis as default };