import { createHash } from '@s-ui/js/lib/hash';
import isPromise from '../../../helpers/isPromise';
export var inMemory = function inMemory(target, cache, original, fnName, instance, ttl) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var key = target.constructor.name + "::" + fnName + "::" + createHash(JSON.stringify(args));
    var now = Date.now();

    if (cache.get(key) === undefined) {
      cache.set(key, {
        createdAt: now,
        returns: original.apply(instance, args)
      });
    }

    if (isPromise(cache.get(key).returns)) {
      cache.get(key).returns.then(function (args) {
        if (args.__INLINE_ERROR__ && Array.isArray(args) && args[0]) {
          cache.del(key);
        }
      })["catch"](function () {
        return cache.del(key);
      });
    }

    if (now - cache.get(key).createdAt > ttl) {
      cache.del(key);
    }

    return cache.get(key) !== undefined ? cache.get(key).returns : original.apply(instance, args);
  };
};