var stringOrIntToMs = function stringOrIntToMs(_ref) {
  var ttl = _ref.ttl;
  var RADIX = 10;

  if (typeof ttl === 'number') {
    return ttl;
  }

  var _ttl$split = ttl.split(' '),
      unit = _ttl$split[0],
      amount = _ttl$split[1];

  try {
    unit = parseInt(unit, RADIX);
  } catch (e) {
    return false;
  }

  switch (amount) {
    case 'second':
    case 'seconds':
      return unit * 1000;

    case 'minute':
    case 'minutes':
      return unit * 1000 * 60;

    case 'hour':
    case 'hours':
      return unit * 1000 * 60 * 60;

    default:
      return false;
  }
};

export default stringOrIntToMs;